import java.util.Arrays;

/*
    Aufgabe 1) Rekursion - Diverse Methoden
*/
public class Aufgabe1 {

    // x <= y
    private static int printAndCountNumbers(int x, int y) {
        if (x > y) {
            System.out.println();
            return 0;
        }
        System.out.print(x + "\t");
        return x + printAndCountNumbers(x + 1, y);
    }

    // x <= y
    private static int printAndCountNumbersDes(int x, int y) {
        if (y < x) {
            System.out.println();
            return 0;
        }
        System.out.print(y + "\t");
        return y + printAndCountNumbersDes(x, y - 1);
    }

    // array != null && array.length > 2 && i+2<array.length
    private static int calcMaxSumTriple(int[] array, int i) {
        if (i + 2 >= array.length) return Integer.MIN_VALUE;
        return Math.max(array[i] + array[i + 1] + array[i + 2], calcMaxSumTriple(array, i + 1));
    }

    // array != null && array.length > 2
    private static int calcMaxSumTriple(int[] array) {
        if (array.length <= 2) return Integer.MIN_VALUE;
        return Math.max(array[0] + array[1] + array[2],
                calcMaxSumTriple(Arrays.copyOfRange(array, 1, array.length)));
    }

    // array != null && array.length > 2.
    private static int findMaxDiff(int[] array, int i) {
        if (i - 1 < 0) return 0;
        return Math.max(Math.abs(array[i] - array[i - 1]), findMaxDiff(array, i - 1));
    }

    public static void main(String[] args) {
        System.out.println(printAndCountNumbers(10, 20));
        System.out.println();
        System.out.println(printAndCountNumbersDes(5, 15));
        System.out.println();

        System.out.println(calcMaxSumTriple(new int[]{1, 4, 8, 3, 7, 3, 8, 2, 7, 4, 3}, 0));
        System.out.println(calcMaxSumTriple(new int[]{1, 4, 8, 3, 7, 1, 8, 7, 3, 4, 3}, 0));
        System.out.println(calcMaxSumTriple(new int[]{7, 5, 3}, 0));

        System.out.println(calcMaxSumTriple(new int[]{1, 4, 8, 3, 7, 3, 8, 2, 7, 4, 3}));
        System.out.println(calcMaxSumTriple(new int[]{1, 4, 8, 3, 7, 1, 8, 7, 3, 4, 3}));
        System.out.println(calcMaxSumTriple(new int[]{7, 5, 3}));
        System.out.println();

        System.out.println(findMaxDiff(new int[]{5, 50, 7, 1, 20}, 4));
        System.out.println(findMaxDiff(new int[]{5, 8, 7, 1, 20}, 2));
        System.out.println(findMaxDiff(new int[]{5, 14, 5, 1, 2, 1, 20}, 6));
        System.out.println(findMaxDiff(new int[]{1, 1, 1, 1, 1, 1, 1}, 6));
        System.out.println(findMaxDiff(new int[]{2, 4}, 1));
    }
}


